
'''''''''''''''''''''''''''''''
''''''' key handling demos ''''
'''''''''''''''''''''''''''''''


'demos:
sub demo1
do
  scankeys
  if ischrpressed(" ") then
    print "space"
  else
    print "no space"
  end if
loop
end sub
    
sub demo2
do
  pause 100
  scankeys
  Print "pressed: ";
  for n=1 to keys.count
    print chrdown$(n);" ";
  next n
loop
end sub

sub demo3
do
  pause 100
  scankeys
  for n=1 to keys.count
    if keys.new(n) then print chrdown$(n);" ";
  next n
loop

end sub

'''''''''''''''''''''''''''
''' code to handle keys '''
'''''''''''''''''''''''''''

dim keys.count
dim keys(6)
dim keys.new(6)

sub scankeys 
  local oldkeys(6)
  local i,j

  'update key count, saving old value
  local oldkeys.count=keys.count
  keys.count=keydown(0)

  'update list of keys down, saving old values.
  for i=1 to 6
    oldkeys(i)=keys(i)
    keys(i)=keydown(i)
  next i

  for i=1 to keys.count

    'the key is a new keypress unless we find it was already pressed.
    keys.new(i)=1

    'check if key(i) was already pressed
    for j=1 to oldkeys.count
      if keys(i) = oldkeys(j) then
        keys.new(i)=0
      end if
    next
  
  next
end sub

function iskeypressed(k)
  local n
  for n=1 to keys.count
    if keys(n) = k then
      iskeypressed=1
      exit function
    end if
  next n
  'if we got all the way through the loops without
  'finding it and exiting, then it's not pressed
  iskeypressed=0
end function

function ischrpressed(c$)
  ischrpressed=iskeypressed(asc(c$))
end function

function chrdown$(i)
  chrdown$=chr$(keys(i))
end function






cls
fc=1: bc=9 : rem Color 1-15
volume=12 : rem Volume 1-25



Flag=0:
s=1: rem sound 1=square 2=sine 3= noise
okt=0 : rem oktave to zero

dim freq(88), ta$(88)

Print "Felder Dimensioniert"

freq(01)=27.5000 : freq(11)=48.9995 : freq(21)=87.3071 : freq(31)=155.563
freq(02)=29.1353 : freq(12)=51.9130 : freq(22)=92.4986 : freq(32)=164.814
freq(03)=30.8677 : freq(13)=55.0000 : freq(23)=97.9989 : freq(33)=174.614
freq(04)=32.7032 : freq(14)=58.2705 : freq(24)=103.826 : freq(34)=184.997
freq(05)=34.6479 : freq(15)=61.7354 : freq(25)=110.000 : freq(35)=195.998
freq(06)=36.7081 : freq(16)=65.4064 : freq(26)=116.541 : freq(36)=207.652
freq(07)=38.8909 : freq(17)=69.2957 : freq(27)=123.471 : freq(37)=220.000
freq(08)=41.2035 : freq(18)=73.4162 : freq(28)=130.813 : freq(38)=233.082
freq(09)=43.6536 : freq(19)=77.7817 : freq(29)=138.591 : freq(39)=246.942
freq(10)=46.2493 : freq(20)=82.4069 : freq(30)=146.832 : freq(40)=261.626

freq(41)=277.183 : freq(51)=493.883 : freq(61)=880.000 : freq(71)=1567.98
freq(42)=293.665 : freq(52)=523.251 : freq(62)=932.328 : freq(72)=1661.22
freq(43)=311.127 : freq(53)=554.365 : freq(63)=987.767 : freq(73)=1760.00
freq(44)=329.628 : freq(54)=587.330 : freq(64)=1046.50 : freq(74)=1864.66
freq(45)=349.228 : freq(55)=622.254 : freq(65)=1108.73 : freq(75)=1975.53
freq(46)=369.994 : freq(56)=659.255 : freq(66)=1174.66 : freq(76)=2093.00
freq(47)=391.995 : freq(57)=698.456 : freq(67)=1244.51 : freq(77)=2217.46
freq(48)=415.305 : freq(58)=739.989 : freq(68)=1318.51 : freq(78)=2349.32
freq(49)=440.000 : freq(59)=783.991 : freq(69)=1396.91 : freq(79)=2489.02
freq(50)=466.164 : freq(60)=830.609 : freq(70)=1479.98 : freq(80)=2637.02

freq(81)=2793.83
freq(82)=2959.96
freq(83)=3135.96  
freq(84)=3322.44
freq(85)=3520.00
freq(86)=3729.31
freq(87)=3951.07  
freq(88)=4186.01

ta$(28)="q"
ta$(29)="2"
ta$(30)="w"
ta$(31)="3"
ta$(32)="e"
ta$(33)="r"
ta$(34)="5"
ta$(35)="t"
ta$(36)="6"
ta$(37)="z"
ta$(38)="7"
ta$(39)="u"
ta$(40)="i"
ta$(41)="9"
ta$(42)="o"
ta$(43)="0"
ta$(44)="p"
freq(tnr)=freq(28)

?"start"


DO
Keyboardtaste:

scankeys

if keys.count > 0 then
  tpress$=chrdown$(1):
  tpressnew=keys.new(1)
else
  tpress$=""
end if

              Print @(10,40);"Taste:";tpress$;"  "
              Print @(10,80);"Buffer:";buffer$;"  "
              Print @(140,80);"Keydown:";kdn
              print @(10,120);"Frequency";freq(tnr);"   "
              Print @(180,120);" ";tdn
if tpress$="" then buffer$="" : Play Stop : goto Keyboardtaste
if tpress$<>"" then goto Checktaste


Checktaste:

if tpress$="q" then tnr=28+okt
if tpress$="2" then tnr=29+okt
if tpress$="w" then tnr=30+okt
if tpress$="3" then tnr=31+okt
if tpress$="e" then tnr=32+okt
if tpress$="r" then tnr=33+okt
if tpress$="5" then tnr=34+okt
if tpress$="t" then tnr=35+okt
if tpress$="6" then tnr=36+okt
if tpress$="z" then tnr=37+okt
if tpress$="7" then tnr=38+okt
if tpress$="u" then tnr=39+okt
if tpress$="i" then tnr=40+okt
if tpress$="9" then tnr=41+okt
if tpress$="o" then tnr=42+okt
if tpress$="0" then tnr=43+okt
if tpress$="p" then tnr=44+okt
if tpressnew then
  if tpress$="+" then okt=okt+12: if okt>36 then okt=36:   rem check it okt gets to high
  if tpress$="-" then okt=okt-12: if okt<-24 then okt=-24: rem check if okt gets too low
end if
if tpress$="a" then s=2
if tpress$="s" then s=1
if tpress$="d" then s=3
if tpress$="f" then s=4

'Check if the same key is pressed, which means the sound is already playing
if buffer$=tpress$ then samesound=1 else samesound=0

buffer$=tpress$

Soundausgabe:

'only use Play Sound command if it's not already playing the right one.
if not samesound then
 If s=1 then Play Sound 1,B,Q,freq(tnr),volume
 if s=2 then play Sound 1,B,S,freq(tnr),volume
 if s=3 then play sound 1,B,N,freq(tnr),volume
 if s=4 then play sound 1,B,P,freq(tnr),volume
end if


LOOP

